/* Auteur - La Massiot - 2005 */

/*_______________________________*/
/*-------------------------------*/
/*           cache.h             */
/*_______________________________*/
/*-------------------------------*/



#include "couche_physique.h"



#define              SIZE_OF_SBLOCK 256
#define   FRACTION_CACHEE_DU_DISQUE 10
#define TAUX_DE_REDUCTION_HASHTABLE 10



typedef int  sblocknum_t;
typedef char * sblock_t;

/* 
   Le cache est une liste doublement chane L double d'une table de hachage H. 
   La table de hachage est un tableau de listes doublement chanes.
   Les lments de ces listes doublement chanes sont de type s_elem_cache.
*/
  
/*------------ Variables ------------*/

extern int size_of_cache;
extern int size_of_hashtable;
extern struct s_list_elem_cache cache;
extern struct s_list_elem_cache * hashtable;

/*------------ Structures -----------*/

struct s_elem_cache
{
  int nro_block;
  char datas [SIZE_OF_SBLOCK];
  struct s_elem_cache * p_prev_elem_cache;
  struct s_elem_cache * p_next_elem_cache;
  struct s_elem_cache * p_next_elem_hash;
  struct s_elem_cache * p_prev_elem_hash;
  int b_to_be_written_physically; 
};



struct s_list_elem_cache
{
  int nb_of_elements_in_cache;
  struct s_elem_cache * p_first_elem_cache;
  struct s_elem_cache * p_last_elem_cache;
};

/*----------- Prototypes ----------*/

error_t init_cache(int nb_total_blocks);
error_t shutdown_cache();
error_t flush_cache();

void enlever_element_de_la_liste(struct s_elem_cache * b);
error_t suppr_last_elem_cache();

void ajouter_element_en_tete_de_liste(struct s_elem_cache * b);
void ajouter_dans_hashtable(struct s_elem_cache * p_new_elem_cache);

error_t update_cache(int nro_block, int b_write, sblock_t block);
error_t read_sblock(sblocknum_t num, sblock_t block);
error_t write_sblock(sblocknum_t num, sblock_t block);
int max(int e1, int e2);

error_t self_test_cache(int m, int nb_test);
