/* Auteur - La Massiot - 2005 */

/*______________________________*/
/*------------------------------*/
/*       couche_physique.c      */ 
/*______________________________*/
/*------------------------------*/

#include "couche_physique.h"

char * disque_fd_glob = "disque_fd_glob";
int fd_disque = -1;



/*-------------------------------------------------------------------------*/
/*                               Start Disk                                */
/*-------------------------------------------------------------------------*/
error_t start_disk()
{
  if(fd_disque != -1)
    return 0;
  
  if((fd_disque = open(disque_fd_glob, O_RDWR | O_CREAT, 00644)) == -1)
    return (ERROR_DISK);

  return 0;
}
/*-------------------------------------------------------------------------*/
/*                                Stop Disk                                */
/*-------------------------------------------------------------------------*/
error_t stop_disk()
{
  if(close(fd_disque) == -1)
    return (ERROR_CLOSE);

  return 0;
}
/*-------------------------------------------------------------------------*/
/*                        Read physical block                              */
/*-------------------------------------------------------------------------*/
error_t read_pblock(pblocknum_t num, pblock_t block)
{
int lus;

  if(lseek(fd_disque, SIZEOF_PBLOCK*num, SEEK_SET) == -1)
    return (ERROR_SEEK);

  lus = read(fd_disque, block, SIZEOF_PBLOCK*sizeof(char));
  
  if(lus != SIZEOF_PBLOCK*sizeof(char))
    return (ERROR_READ);

  return 0;
}
/*-------------------------------------------------------------------------*/
/*                       Write physical block                              */
/*-------------------------------------------------------------------------*/
error_t write_pblock(pblocknum_t num, pblock_t block)
{
int ecrits;

  if(lseek(fd_disque, SIZEOF_PBLOCK*num, SEEK_SET) == -1)
    return (ERROR_SEEK);

  ecrits = write(fd_disque, block, SIZEOF_PBLOCK*sizeof(char));
  
  if(ecrits != SIZEOF_PBLOCK*sizeof(char))
    return (ERROR_WRITE);

  return 0;
}
/*-------------------------------------------------------------------------*/
/*                              Print block                                */
/*-------------------------------------------------------------------------*/
void print_block(pblock_t block)
{
int i;

  for(i=0 ; i<SIZEOF_PBLOCK ; i++)
  {
    printf("--%d : %c--\n", i+1, block[i]);
  }
  printf("\n");
}
/*-------------------------------------------------------------------------*/
/*                              Fill block                                 */
/*-------------------------------------------------------------------------*/
void fill_block(pblock_t block)
{
int i;

  for(i=0 ; i<SIZEOF_PBLOCK ; i++)
  {
    block[i] = 'a';
  }
  return;
}
